/* FUNCIONES DE ASTRONOMIA */
/* Rubn D¡ez L zaro */
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include<ncurses.h>
#include "astronom.h"

/* deg -> rad */
double deg_rad(double deg)
{
return (deg*M_PI/180);
}

/* rad -> deg */
double rad_deg(double rad)
{
return (rad*180/M_PI);
}

/* deg, min, seg -> deg */
double dms_deg(int de, int min, float seg)
{
if(de<0) {
		min=-min;
		seg=-seg;
		}
if((de==0)&&(min<0)) seg=-seg;
return (((seg/60)+min)/60)+de;
}

/* coseno en deg, min y seg */
double dcos(int deg, int min, float seg)
{
return cos(deg_rad(dms_deg(deg, min, seg)));
}

/* seno en deg, min y seg */
double dsin(int deg, int min, float seg)
{
return sin(deg_rad(dms_deg(deg, min, seg)));
}

/* tangente en deg, min y seg */
double dtan(int deg, int min, float seg)
{
return tan(deg_rad(dms_deg(deg, min, seg)));
}

/* imprime radianes en deg, min y seg sesagesimales */
void rad_dms(double rad)
{
float g, mn, s;
g=rad_deg(rad);
if((g>=360)||(g<0)) g=g-floor(g/360)*360;
mn=(g-floor(g))*60;
g=floor(g);
s=(mn-floor(mn))*60;
mn=floor(mn);
if(s>=60){
	mn=mn+floor(s/60);
	s=s-floor(s/60)*60;
	}
if(mn>=60){
	g=g+floor(mn/60);
	mn=mn-floor(mn/60)*60;
	}
printw("%03.0f %02.0f' %04.1f''",g, mn, aprox(s, 1));
}

/* calcula el dia juliano (tiene en cuenta la reforma gregoriana)*/
double dj(int a, int m, float d, float h, float mn, float s)
{
double djc;
unsigned int n;

if((m>12)||(h>=24)||(mn>=60)||(s>=60)||(m<=0)||(d<=0)||(h<0)||(mn<0)||(s<0)||((d>31)&&((m==1)||(m==3)||(m==5)||(m==7)||(m==8)||(m==10)||(m==12)))||((d>30)&&((m==4)||(m==6)||(m==9)||(m==11)))||((d>(28+bis(a)))&&(m==2))||
(a!=(int)floor(a))||(m!=(int)floor(m)))
					{
					endwin();
					printf("ERROR: Fecha no válida. \n");
					exit(1);
					}

if((a==1582)&&(m==10)&&((d>4)&&(d<15))){
				endwin();
				printf("ERROR: La fecha no existe debido a la reforma gregoriana. \n");
				exit(1);
				}

if(a<1583) djc=ceil((4712+a)*365.25);
if(a>1582) {
	if(a>=1600){
		n=(floor(a/400)-4)*3;
		if(((a-floor(a/400)*400)<=200)&&((a-floor(a/400)*400)>100)) n=n+1;
		if(((a-floor(a/400)*400)<=300)&&((a-floor(a/400)*400)>200)) n=n+2;
		if(((a-floor(a/400)*400)<=400)&&((a-floor(a/400)*400)>300)) n=n+3;
		}
	else n=0;

djc=ceil((4712+a)*365.25)-10-n;
}
switch(m){
	case 1: djc=djc;
	break;
	case 2: djc=djc+31;
	break;
	case 3: djc=djc+59+bis(a);
	break;
	case 4: djc=djc+90+bis(a);
	break;
	case 5: djc=djc+120+bis(a);
	break;
	case 6: djc=djc+151+bis(a);
	break;
	case 7: djc=djc+181+bis(a);
	break;
	case 8: djc=djc+212+bis(a);
	break;
	case 9: djc=djc+243+bis(a);
	break;
	case 10: djc=djc+273+bis(a);
		if((a==1582)&&(d>=15)) djc=djc-10;
	break;
	case 11: djc=djc+304+bis(a);
		if(a==1582) djc=djc-10;
	break;
	case 12: djc=djc+334+bis(a);
		if(a==1582) djc=djc-10;
	break;
	default: endwin(); printf("ERROR: mes no válido. \n"); exit(1);
	}
djc=djc+(d-1)+((h+(mn/60)+(s/3600))-12)/24;

return djc;
}

/* devuelve un 1 si el a¤o es bisiesto y 0 si no lo es
(tiene en cuenta la reforma gregoriana)*/
int bis(int ano)
{
if(ano<1583){
	if((double)ano/4==ceil((double)ano/4)) return 1;
/*	else return 0;*/
	}
else if(ano>1582){
	if(((double)ano/4==ceil((double)ano/4)&&(double)ano/400==ceil((double)ano/400))||((double)ano/4==ceil((double)ano/4)&&(double)ano/100!=ceil((double)ano/100)))
	return 1;
/*	else return 0;*/
	}

return 0;
}

/* A.R. del sol medio para un dia juliano */
double arsm(double djuli)
{
double T;
double resul;
T=(djuli-(double)2451545)/(double)36525;
resul=(((double)67310.54841+(double)8640184.8129*T+(double)0.0931*T*T)/(double)3600);
if((resul>=24)||(resul<0)) resul=resul-floor(resul/24)*24;
return resul;
}

/* hora siderea en greenwhich para un dia juliano */
double tsg(int a, int m, float d, float h, float mn, float s)
{
return (arsm(dj(a, m, d, h, mn, s))+((double)h+(double)mn/60+(double)s/3600-(double)12));
}

/* horas a hora, minutos y segundos */
void hora_hms(double hora)
{
int h;
float m, s;
if((hora>=24)||(hora<0)) hora=hora-floor(hora/24)*24;
m=((float)hora-(float)floor(hora))*60;
h=(int)floor(hora);
s=(m-(float)floor(m))*60;
m=(float)floor(m);
if(s>=60){
	m=m+(float)floor(s/60);
	s=s-(float)floor(s/60)*60;
	}
if(m>=60){
	h=h+(int)floor(m/60);
	m=m-(float)floor(m/60)*60;
	}
printw("%02dh %02.0fm %04.1fs",h, m, s=aprox(s, 1));
}

/* Dada una fecha con un valor fuera de rango, la optimiza. */
/* La fecha optimizada ser  conservada en 6 float consecutivos. El puntero */
/* del primer valor es especificado por el 1§ par metro de la funci¢n. */
/*Los valores se guardan en el orden (a¤o, mes, d¡a, hora, minuto, segundo).*/
/* (No vale para mes, d¡a, hora, minuto, segundos negativo; ni a¤o, mes */
/* no enteros). */
/* Tiene en cuenta la reforma gregoriana */
/* (al 4-oct de 1582 le sigue el 15-oct de 1582). */
/*DEBE RESERVARSE MEMORIA EN EL PROGRAMA PRINCIPAL PERA CONTENER LOS VALORES*/
/* (6 DATOS TIPO FLOAT) */
/* DE NO HACERSE ASI EL SISTEMA PUEDE CASCAR */
void ordena(float *or, int an, int me, float di, float ho, float mi, float se)
{
if((me<0)||(di<0)||(ho<0)||(mi<0)||(se<0)||(an!=(int)floor(an))||(me!=(int)floor(me))){
				endwin();
				printf("ERROR: Valor de fecha negativo o año/mes no entero.\n");
				exit(1);
				}

ho=ho+(di-(float)floor(di))*24;
di=(float)floor(di);
mi=mi+(ho-(float)floor(ho))*60;
ho=(float)floor(ho);
se=se+(mi-(float)floor(mi))*60;
mi=(float)floor(mi);

if(se>=60){
	mi=mi+floor(se/60);
	se=se-floor(se/60)*60;
	}
if(mi>=60){
	ho=ho+floor(mi/60);
	mi=mi-floor(mi/60)*60;
	}
if(ho>=24){
	di=di+floor(ho/24);
	ho=ho-floor(ho/24)*24;
	}
if(me>12){
	an=an+floor((float)me/12);
	me=me-floor((float)me/12)*12;
	}

switch(me){
	case 1: di=di;
		me=0;
	break;
	case 2: di=di+31;
		me=0;
	break;
	case 3: di=di+59+bis(an);
		me=0;
	break;
	case 4: di=di+90+bis(an);
		me=0;
	break;
	case 5: di=di+120+bis(an);
		me=0;
	break;
	case 6: di=di+151+bis(an);
		me=0;
	break;
	case 7: di=di+181+bis(an);
		me=0;
	break;
	case 8: di=di+212+bis(an);
		me=0;
	break;
	case 9: di=di+243+bis(an);
		me=0;
	break;
	case 10: di=di+273+bis(an);
		me=0;
	break;
	case 11: di=di+304+bis(an);
		me=0;
	break;
	case 12: di=di+334+bis(an);
		me=0;
	break;
	default: endwin(); printf("ERROR: mes no válido. \n"); exit(1);
	}
while(di>(365+bis(an))){
		di=di-(365+bis(an));
		an=an+1;
	}
if((di<=(365+bis(an)))&&(di>(334+bis(an)))){
		me=12;
		di=di-(334+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(334+bis(an)))&&(di>(304+bis(an)))){
		me=11;
		di=di-(304+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(304+bis(an)))&&(di>(273+bis(an)))){
		me=10;
		di=di-(273+bis(an));
if((an==1582)&&((di>4)&&(di<15))) di=di+10;
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(273+bis(an)))&&(di>(243+bis(an)))){
		me=9;
		di=di-(243+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(243+bis(an)))&&(di>(212+bis(an)))){
		me=8;
		di=di-(212+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(212+bis(an)))&&(di>(181+bis(an)))){
		me=7;
		di=di-(181+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(181+bis(an)))&&(di>(151+bis(an)))){
		me=6;
		di=di-(151+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(151+bis(an)))&&(di>(120+bis(an)))){
		me=5;
		di=di-(120+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(120+bis(an)))&&(di>(90+bis(an)))){
		me=4;
		di=di-(90+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(90+bis(an)))&&(di>(59+bis(an)))){
		me=3;
		di=di-(59+bis(an));
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=(59+bis(an)))&&(di>31)){
		me=2;
		di=di-31;
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

if((di<=31)&&(di>0)){
		me=1;
		di=di;
*or=(float)an;
*(or+1)=(float)me;
*(or+2)=di;
*(or+3)=ho;
*(or+4)=mi;
*(or+5)=se;
return;
		}

}

/* ecuaci¢n de los equinoccios (tsv-tsm) en segundos. */
double eceq(double djuli)
{
return (-1.05*sin(deg_rad(344)-deg_rad(0.052954)*djuli)-0.08*sin(deg_rad(123)+deg_rad(1.9713)*djuli));
}

/* dado un dia juliano, devuelve:
 1 si es Lunes..., 6 si es S bado, 7 si es Domingo */
int dia_sem(int a, int m, float d)
{
return ((int)(dj(a, m, d, 12, 0, 0)-floor(dj(a, m, d, 12, 0, 0)/7)*7+1));
}

/* Aproxima un valor double (o float) a n cifras decimales (maximo 6).
La funcion printf no lo hace bien (por ejem., el valor s=0.959702 con el
formato %04.1f lo imprime como 0001, cuando debiera hacerlo como 01.0). 
Recomiendo usarla A LA VEZ que las instrucciones de formato de printf. */
float aprox(double s, int n)
{
if((n>6)||(n!=floor(n))){
		endwin();
		printf("ERROR: número de cifras decimales demasiado alto o no entero.\n");
		exit(1);
		}
s=s*pow(10, n);
if((s-floor(s))>0.5) s=s+1;
s=floor(s)/pow(10, n);
return (float)s;
}

