#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<ncurses.h>
#include"astronom.h"

char opc;
char sig;
float hl, ml, sl;

void alto(void)
{
endwin();
printf("ERROR: El año es demasiado alto para salir en la tabla.\n");
exit(1);
}

void bajo(void)
{
endwin();
printf("ERROR: El año es demasiado bajo para salir en la tabla.\n");
exit(1);
}

void nolong(void)
{
endwin();
printf("ERROR: Longitud no válida.\n");
exit(1);
}

void pres(void)
{
erase();
printw(".------------+-------------+--------------+-------------+--------------------.\n");
printw("|   FECHA    |    HORA     |     DIA      | H MEDIA EN  |  H VERDADERA PARA  |\n");
printw("|(dd/mm/aaaa)|    T.U.     |   JULIANO    |  GREENWICH  |");
if(opc=='1')printw(" L=%c%02.0fh %02.0fm %04.1fs W |\n",sig, hl, ml, aprox(sl, 1));
if(opc=='2')printw("L=%c%03.0fº %02.0f' %04.1f'' W|\n",sig, hl, ml, aprox(sl, 1));
printw("+------------+-------------+--------------+-------------+--------------------+\n");
refresh();
return;
}

void dedica(void)
{
printw("\n\n\n");
printw("HORA SIDEREA version 1\n");
printw(".==========================================================.\n");
printw("| Rubén Díez Lázaro, Octubre 1997.      Dedicado a Raquel. |\n");
printw("| Portado a POSIX usando NCURSES en Abril de 2014.         |\n");
printw("`=========================================================='\n");
refresh();
sleep(3);
erase();
}



int main()
{
int ano, mes;
float dia, hora, minu, seg;
int anof, mesf;
float diaf, horaf, minuf, segf;
float d, h, m, s;
double l;
float *ord;
int i=0;
int nrow, ncol;

initscr();
cbreak();
echo();
erase();

getmaxyx(stdscr, nrow, ncol);
if(ncol<79){
			endwin();
			printf("ERROR: La terminal debe tener al menos 79 caracteres de ancho.\n(pero este terminal tiene %d)",ncol);
			exit(1); }

if(nrow<22){
			endwin();
			printf("ERROR: La terminal debe tener al menos 22 lineas de alto.\n(pero este terminal tiene %d)",nrow);
			exit(1); }


printw("\n\n");
printw("Introduzca la 1ª fecha de la tabla de hora siderea. \nFormato AAAA MM DD HH MN SG:\t");
refresh(); scanw("%d %d %f %f %f %f",&ano, &mes, &dia, &hora, &minu, &seg);
printw("\n\n");
if(ano>9999) alto();
if(ano<-9999) bajo();
printw("Introduzca la última fecha de la tabla de hora siderea. \nFormato AAAA MM DD HH MN SG:\t");
refresh(); scanw("%d %d %f %f %f %f",&anof, &mesf, &diaf, &horaf, &minuf, &segf);
printw("\n\n");
if(anof>9999) alto();
if(anof<-9999) bajo();
if(dj(anof, mesf, diaf, horaf, minuf, segf)<dj(ano, mes, dia, hora, minu, seg)){
					endwin();
					printf("ERROR: La fecha final es menor que la inicial.\n");
					exit(1); }
printw("Introduzca el intervalo entre fechas de la tabla. \nFormato DD HH MN:\t");
refresh(); scanw("%f %f %f",&d, &h, &m);
	if((d<0)||(h<0)||(m<0)||((d==0)&&(h==0)&&(m==0))){
		endwin();
		printf("ERROR: Alguno de los valores del intervalo entre fechas es negativo\n\to todos son cero.\n");
		exit(1);}
h=h+(d-(float)floor(d))*24;
d=(float)floor(d);
m=m+(h-(float)floor(h))*60;
h=(float)floor(h);
s=(m-(float)floor(m))*60;
m=(float)floor(m);

if(s>=60){
	m=m+(float)floor(s/60);
	s=s-(float)floor(s/60)*60;
	}
if(m>=60){
	h=h+(float)floor(m/60);
	m=m-(float)floor(m/60)*60;
	}
if(h>=24){
	d=d+(float)floor(h/24);
	h=h-(float)floor(h/24)*24;
	}
	if(d>32700){
		endwin();
		printf("ERROR: El intervalo es demasiado grande.\n");
		exit(1);}
printw("\n\n");
do{
	printw("Elija el formato para la longitud del lugar: \n");
	printw("                                            1- En horas\n");
	printw("                                            2- En grados\n");
	refresh(); opc=getch();
}while((opc<'1')||(opc>'2'));
printw("\n\n");
switch(opc){
	case '1':
		printw("Introduzca longitud del lugar (positiva hacia el oeste). \n(Especificar signo en el primer valor distinto de 0). \nFormato ±HH MN SG:\t");
		refresh(); scanw("%f %f %f",&hl, &ml, &sl);
ml=ml+(hl-(float)floor(hl))*60;
hl=(float)floor(hl);
sl=sl+(ml-(float)floor(ml))*60;
ml=(float)floor(ml);

		if((hl>=24)||(hl<=-24)||((hl!=0)&&(ml<0))||((hl==0)&&(ml!=0)&&(sl<0))||(ml>=60)||(ml<=-60)||(sl>=60)||(sl<=-60)) nolong();
	if((hl<0)||(ml<0)||(sl<0)){
		if(hl<0) {l=hl-ml/60-sl/3600;
			hl=-hl;
			sig='-';}
		if((hl==0)&&(ml<0)) {l=ml/60-sl/3600;
			ml=-ml;
			sig='-';}
		if((hl==0)&&(ml==0)&&(sl<0)) {l=sl/3600;
			sl=-sl;
			sig='-';}
	}
	else {l=hl+ml/60+sl/3600;
			sig='+';}
		printw("\n");
		break;
	case '2':
		printw("Introduzca longitud del lugar (positiva hacia el oeste). \n(Especificar signo en el primer valor distinto de 0). \nFormato ±GGG MM SS:\t");
		refresh(); scanw("%f %f %f",&hl, &ml, &sl);
ml=ml+(hl-(float)floor(hl))*60;
hl=(float)floor(hl);
sl=sl+(ml-(float)floor(ml))*60;
ml=(float)floor(ml);

		if((hl>=360)||(hl<=-360)||((hl!=0)&&(ml<0))||((hl==0)&&(ml!=0)&&(sl<0))||(ml>=60)||(ml<=-60)||(sl>=60)||(sl<=-60)) nolong();
	if((hl<0)||(ml<0)||(sl<0)){
		if(hl<0) {l=(hl-ml/60-sl/3600)/15;
			hl=-hl;
			sig='-';}
		if((hl==0)&&(ml<0)) {l=(ml/60-sl/3600)/15;
			ml=-ml;
			sig='-';}
		if((hl==0)&&(ml==0)&&(sl<0)) {l=(sl/3600)/15;
			sl=-sl;
			sig='-';}
	}
	else {l=(hl+ml/60+sl/3600)/15;
			sig='+';}
		printw("\n");
		break;
	}
if((l>=24)||(l<=-24)) nolong();

ord=malloc(6*sizeof(float)); /*reserva memória para los valores retornados*/
			     /*por la función ordena*/
if(!ord){endwin(); printf("\nNO HAY MEMEORIA SUFICIENTE\n");
	exit(1);}
pres();
do{
 if(i>(nrow-7)){
	printw("`------------+-------------+--------------+-------------+--------------------'\n");
	printw("Pulse una tecla para continuar...");
	refresh(); getch();
	printw("\n");
	i=0;
	pres();
	}
 if(i!=0) printw("+------------+-------------+--------------+-------------+--------------------+\n");
i+=2;

	printw("| %02.0f/%02d/",dia, mes);
	if(ano<0) printw("%05d",ano);
	else printw("%04d ", ano);
	printw("|%02.0fh %02.0fm %04.1fs",hora, minu, aprox(seg, 1));
	if(dj(ano, mes, dia, hora, minu, seg)<0) printw("|%014.5f",aprox(dj(ano, mes, dia, hora, minu, seg), 5));
	else printw("|%014.6f",aprox(dj(ano, mes, dia, hora, minu, seg), 6));
	printw("|");
	hora_hms(tsg(ano, mes, dia, hora, minu, seg));
	printw("|   ");
	hora_hms(tsg(ano, mes, dia, hora, minu, seg)-l+eceq(dj(ano, mes, dia, hora, minu, seg))/3600);
	printw("    |\n");

	seg=seg+s;
	minu=minu+m;
	hora=hora+h;
	dia=dia+d;
ordena(ord, ano, mes, dia, hora, minu, seg);
	ano=(int)*ord;
	mes=(int)*(ord+1);
	dia=(float)*(ord+2);
	hora=(float)*(ord+3);
	minu=(float)*(ord+4);
	seg=(float)*(ord+5);
}while(dj(ano, mes, dia, hora, minu, seg)<=dj(anof, mesf, diaf, horaf, minuf, segf));

printw("`------------+-------------+--------------+-------------+--------------------'\n");
printw("Pulse una tecla para finalizar...");
refresh(); getch();
free(ord);
erase();
dedica();

endwin();
return 0;
}

